uniform sampler2DRect textureNow;
uniform sampler2DRect textureDelay;
uniform int mixType;

void main(void)
{
	vec4 colorNow = texture2DRect( textureNow, gl_TexCoord[0].xy );
	vec4 colorDelay = texture2DRect( textureDelay, gl_TexCoord[0].xy );
	if( mixType == 0 )
	{
		// max
		gl_FragColor = max( colorNow, colorDelay );
	}else if( mixType == 1 )
	{
		// multiply
		gl_FragColor = colorNow * colorDelay;
	}else if( mixType == 2 )
	{
		// subtract
		gl_FragColor = abs( colorNow - colorDelay );
		gl_FragColor.a = 1.0;
	}else if( mixType == 3 )
	{
		// subtract inverted
		vec4 colorDelayInverted = vec4( 1.0 ) - colorDelay;
		gl_FragColor = abs( colorNow - colorDelayInverted );
		gl_FragColor.a = 1.0;
	}
}